Codeforces-148D-Bag of mice (Probability DP)
https://blog.csdn.net/u012860063/article/details/43702983
设dp[i][j]表示现在轮到王妃抓时有i只白鼠,j只黑鼠,王妃赢的概率;
明显 dp[0][j] = 0, 0<=j<=b;
因为没有白色老鼠了
dp[i][0] = 1, 1<=i<=w;
因为都是白色老鼠,抓一次肯定赢了。
dp[i][j]可以转化成下列四种状态:
1、王妃抓到一只白鼠,则王妃赢了,概率为i/(i+j);
2、王妃抓到一只黑鼠,龙抓到一只白色,则王妃输了,概率为j/(i+j)*i/(i+j-1).
3、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只黑鼠,则转移到dp[i][j-3]。
概率为j/(i+j)*(j-1)/(i+j-1)*(j-2)/(i+j-2);
4、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只白鼠,则转移到dp[i-1][j-2].
概率为j/(i+j)*(j-1)/(i+j-1)*i/(i+j-2);
当然后面两种情况要保证合法,即第三种情况要至少3只黑鼠,第四种情况要至少2只白鼠
for(int i = 1; i <= w; i++)
{
dp[i][0] = 1;//全是白鼠
}
for(int i = 0; i <= b; i++)
{
dp[0][i] = 0;//全是黑鼠
}
for(int i = 1; i <= w; i++)
{
for(int j = 1; j <= b; j++)
{
// if(i==0 && j==0)
// continue;
//王妃直接抓到白鼠
dp[i][j] += (double)i/(i+j);
//王妃和龙都抓的黑鼠,随机跑出来的也是黑鼠
if(j >= 3)
dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(j-2)/(i+j-2)*dp[i][j-3];
//王妃和龙都抓的黑鼠,随机跑出来的是白鼠
if(i>=1 && j>=2)
dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(i)/(i+j-2)*dp[i-1][j-2];
}
}
https://blog.csdn.net/qq_38538733/article/details/77848120
设dp[i][j]为袋子中有i只白鼠,j只黑鼠时王妃的获胜概率,那么可以知道dp[i][0]一定是等于1的,dp[0][j]一定等于0;
然后整个过程不外乎四种情况:
① 王妃直接抓到白鼠;
② 王妃抓到黑鼠,龙抓到白鼠;
③ 王妃抓到黑鼠,龙抓到黑鼠,跑出一只黑鼠;
④ 王妃抓到黑鼠,龙抓到黑鼠,跑出一只白鼠;
前两种情况直接用,第三种情况要满足j>=3;第四种情况要满足j>=2;
http://www.cnblogs.com/plumrain/p/CF_148D.html
http://kemlkyo-blog.logdown.com/posts/209233-codeforces148-d-bag-of-mice
Read full article from Problem - 148D - Codeforces
The dragon and the princess are arguing about what to do on the New Year's Eve. The dragon suggests flying to the mountains to watch fairies dancing in the moonlight, while the princess thinks they should just go to bed early. They are desperate to come to an amicable agreement, so they decide to leave this up to chance.
They take turns drawing a mouse from a bag which initially contains w white and b black mice. The person who is the first to draw a white mouse wins. After each mouse drawn by the dragon the rest of mice in the bag panic, and one of them jumps out of the bag itself (the princess draws her mice carefully and doesn't scare other mice). Princess draws first. What is the probability of the princess winning?
If there are no more mice in the bag and nobody has drawn a white mouse, the dragon wins. Mice which jump out of the bag themselves are not considered to be drawn (do not define the winner). Once a mouse has left the bag, it never returns to it. Every mouse is drawn from the bag with the same probability as every other one, and every mouse jumps out of the bag with the same probability as every other one.
Input
The only line of input data contains two integers w and b (0 ≤ w, b ≤ 1000).
Output
Output the probability of the princess winning. The answer is considered to be correct if its absolute or relative error does not exceed10 - 9.
Sample test(s)
input
1 3
output
0.500000000
input
5 5
output
0.658730159
Note
Let's go through the first sample. The probability of the princess drawing a white mouse on her first turn and winning right away is 1/4. The probability of the dragon drawing a black mouse and not winning on his first turn is 3/4 * 2/3 = 1/2. After this there are two mice left in the bag — one black and one white; one of them jumps out, and the other is drawn by the princess on her second turn. If the princess' mouse is white, she wins (probability is 1/2 * 1/2 = 1/4), otherwise nobody gets the white mouse, so according to the rule the dragon wins.
设dp[i][j]表示现在轮到王妃抓时有i只白鼠,j只黑鼠,王妃赢的概率;
明显 dp[0][j] = 0, 0<=j<=b;
因为没有白色老鼠了
dp[i][0] = 1, 1<=i<=w;
因为都是白色老鼠,抓一次肯定赢了。
dp[i][j]可以转化成下列四种状态:
1、王妃抓到一只白鼠,则王妃赢了,概率为i/(i+j);
2、王妃抓到一只黑鼠,龙抓到一只白色,则王妃输了,概率为j/(i+j)*i/(i+j-1).
3、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只黑鼠,则转移到dp[i][j-3]。
概率为j/(i+j)*(j-1)/(i+j-1)*(j-2)/(i+j-2);
4、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只白鼠,则转移到dp[i-1][j-2].
概率为j/(i+j)*(j-1)/(i+j-1)*i/(i+j-2);
当然后面两种情况要保证合法,即第三种情况要至少3只黑鼠,第四种情况要至少2只白鼠
for(int i = 1; i <= w; i++)
{
dp[i][0] = 1;//全是白鼠
}
for(int i = 0; i <= b; i++)
{
dp[0][i] = 0;//全是黑鼠
}
for(int i = 1; i <= w; i++)
{
for(int j = 1; j <= b; j++)
{
// if(i==0 && j==0)
// continue;
//王妃直接抓到白鼠
dp[i][j] += (double)i/(i+j);
//王妃和龙都抓的黑鼠,随机跑出来的也是黑鼠
if(j >= 3)
dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(j-2)/(i+j-2)*dp[i][j-3];
//王妃和龙都抓的黑鼠,随机跑出来的是白鼠
if(i>=1 && j>=2)
dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(i)/(i+j-2)*dp[i-1][j-2];
}
}
https://blog.csdn.net/qq_38538733/article/details/77848120
设dp[i][j]为袋子中有i只白鼠,j只黑鼠时王妃的获胜概率,那么可以知道dp[i][0]一定是等于1的,dp[0][j]一定等于0;
然后整个过程不外乎四种情况:
① 王妃直接抓到白鼠;
② 王妃抓到黑鼠,龙抓到白鼠;
③ 王妃抓到黑鼠,龙抓到黑鼠,跑出一只黑鼠;
④ 王妃抓到黑鼠,龙抓到黑鼠,跑出一只白鼠;
前两种情况直接用,第三种情况要满足j>=3;第四种情况要满足j>=2;
http://www.cnblogs.com/plumrain/p/CF_148D.html
题意:袋子里有w只白鼠和b只黑鼠。龙和公主轮流从袋子里抓老鼠。谁先抓到白色老师谁就赢。公主每次抓一只老鼠,龙每次抓完一只老鼠之后会有一只老鼠跑出来。每次抓老鼠和跑出来的老鼠都是随机的。如果两个人都没有抓到白色老鼠则龙赢。公主先抓。问公主赢的概率。
解法:就是最普通的概率DP,加了些限制条件。设p[i][j]表示袋子里有i只白鼠,j只黑鼠时,公主先抓公主赢的概率。
边界条件p[0][0] = 0,p[i][0] = 1,p[0][i] = 0,p[i][1] = i / (i+1)。
状态转移方程p[i][j] = i/(i+1) + j/(i+j) * (j-1)/(i+j-1) * ((j-2)/(i+j-2) * p[i][j-3] + i/(i+j-2) * p[i-1][j-2])。
12 #define CLR(x) memset(x, 0, sizeof(x)) 13 14 double p[1005][1005]; 15 16 void DP() 17 { 18 CLR (p); 19 for (int i = 0; i <= 1001; ++ i){ 20 p[i][0] = 1.0; 21 p[0][i] = 0.0; 22 p[i][1] = (double)i / (i + 1); 23 } 24 for (int i = 1; i <= 1001; ++ i) 25 for (int j = 2; j <= 1001; ++ j){ 26 p[i][j] = (double)i / (i + j); 27 double tmp = (double)j * (j-1) / (i + j) / (i + j - 1); 28 if (j > 2) 29 p[i][j] += tmp * (double)(j-2)/(i+j-2) * p[i][j-3]; 30 p[i][j] += tmp * (double)i/(i+j-2) * p[i-1][j-2]; 31 } 32 } 33 34 int main() 35 { 36 DP(); 37 int w, b; 38 while (scanf ("%d%d", &w, &b) != EOF) 39 printf ("%.10f\n", p[w][b]); 40 return 0; 41 }http://blog.csdn.net/xingyeyongheng/article/details/25545219
- 分析:假设dp[i][j]表示轮到王妃抓老鼠时面对剩余i只白鼠和j只黑鼠的胜率
- 则dp[i][j]可以转化到以下四种情况:
- 1.王妃胜利,转化概率为i/(i+j)
- 2.dp[i-1][j-2]---王妃抓黑鼠,龙抓黑鼠,逃跑白鼠,转化概率是j/(i+j) * (j-1)/(i+j-1) * i/(i+j-2)
- 3.dp[i-1][j-1]---王妃抓到黑鼠,龙抓到白鼠,输!,转化概率为j/(i+j) * i/(i+j-1)//这不能到达,到达就输了
- 4.dp[i][j-3]--王妃抓到黑鼠,龙抓到黑鼠,逃跑黑鼠,转化率为j/(i+j) * (j-1)/(i+j-1) * (j-2)/(i+j-2)
- const int MAX=1000+10;
- int w,b;
- double dp[MAX][MAX];
- int main(){
- while(cin>>w>>b){
- for(int i=1;i<=w;++i)dp[i][0]=1;//有白鼠无黑鼠胜率为1
- for(int i=0;i<=b;++i)dp[0][i]=0;//无白鼠胜率为0
- for(int i=1;i<=w;++i){
- for(int j=1;j<=b;++j){
- dp[i][j]=i*1.0/(i+j);
- //dp[i][j]+=j*1.0/(i+j) * i*1.0/(i+j-1) * dp[i-1][j-1];
- if(j>=2)dp[i][j]+=j*1.0/(i+j) * (j-1)*1.0/(i+j-1) * i*1.0/(i+j-2) * dp[i-1][j-2];
- if(j>=3)dp[i][j]+=j*1.0/(i+j) * (j-1)*1.0/(i+j-1) * (j-2)*1.0/(i+j-2) * dp[i][j-3];
- }
- }
- printf("%.9f\n",dp[w][b]);
- }
- return 0;
- }
http://kemlkyo-blog.logdown.com/posts/209233-codeforces148-d-bag-of-mice
DP状态设计
这里用第二种方法,转移时一次走两步
转移方程
这四种情况的概率累加,得f[i][j]
边界
double f[1001][1001]; int w,b; int main(){ scanf("%d%d",&w,&b); for (int i=0;i<=w;i++) f[i][0]=1; for (int i=0;i<=b;i++) f[0][i]=0; for (int i=1;i<=w;i++) for (int j=1;j<=b;j++){ f[i][j]+=(double)i/(i+j); //公主抽出白的 if (j>=3) f[i][j]+=(double)j/(i+j)*((double)(j-1)/(i+j-1))*((double)(j-2)/(i+j-2))*f[i][j-3]; //公主抽出黑的,龙抽出黑的,跑出一只黑的 if (j>=2) f[i][j]+=(double)j/(i+j)*((double)(j-1)/(i+j-1))*((double)i/(i+j-2))*f[i-1][j-2]; } printf("%.9lf\n",f[w][b]); }
Read full article from Problem - 148D - Codeforces